
ChiliProject - Feature # 298: Seperate core plugins and user plugins into different directories

Status: Closed Priority: Normal
Author: Holger Just Category: Plugin API
Created: 2011-03-19 Assignee: Eric Davis
Updated: 2011-12-09 Due date:
Remote issue URL: http://www.redmine.org/issues/5306
Affected version:
Description: Currently, core-plugins and user plugins are interleaved in @vendor/plugins@ That makes it a mess to 

upgrade the system, as the users have to check which plugins to copy over and which ones not.

A basic solution for that could be configuring something like this

<pre><code class="ruby">
# config/environment.rb

  # Insert vendor/chiliproject_plugins at the top of the plugin load paths
  config.plugin_paths.insert(0, File.join(Rails.root, "vendor", "chiliproject_plugins"))
</code></pre>

Associated revisions
2011-10-14 11:29 pm - Eric Davis
[#298] Add vendor/chiliproject_plugins to the load path

Contributed by Holger Just

History
2011-03-19 07:49 pm - Eric Davis
So would you propose putting all core plugins into @vendor/core_plugins@ and "ChiliProject Plugins" into @vendor/plugins@?

<pre>
vendor/plugins/
â”œâ”€â”€ parallel_tests
â”œâ”€â”€ chiliproject_foo
â””â”€â”€ chiliproject_bar
vendor/core_plugins/
â”œâ”€â”€ acts_as_activity_provider
â”œâ”€â”€ acts_as_attachable
â”œâ”€â”€ acts_as_customizable
â”œâ”€â”€ acts_as_event
â”œâ”€â”€ acts_as_list
â”œâ”€â”€ acts_as_searchable
â”œâ”€â”€ acts_as_tree
â”œâ”€â”€ acts_as_versioned
â”œâ”€â”€ acts_as_watchable
â”œâ”€â”€ awesome_nested_set
â”œâ”€â”€ classic_pagination
â”œâ”€â”€ engines
â”œâ”€â”€ gravatar
â”œâ”€â”€ open_id_authentication
â”œâ”€â”€ prepend_engine_views
â”œâ”€â”€ rfpdf
â””â”€â”€ ruby-net-ldap-0.0.4

2011-03-19 08:01 pm - Felix Schäfer
Eric Davis wrote:
> So would you propose putting all core plugins into @vendor/core_plugins@ and "ChiliProject Plugins" into @vendor/plugins@?

@vendor/plugins@ is a "standard" rails directory and I wouldn't want to change its meaning. Rather add a @vendor/chiliproject_plugins@ or why not a 
@chiliproject/plugins@.

2011-03-19 08:59 pm - Aleksey Zapparov
I agree with Felix, except I totally dislike idea of @chiliproject/plugins@. But I would like to propose @vendor/chili_plugins@ as it's anyway clearly 
states which plugins are in the directory while name stay not so long :))

2011-03-21 11:21 pm - Eric Davis
-1 on @chiliproject/plugins@. @vendor@ is generally accepted to be third-party code so we should keep these in there.

Still not sure where in @vendor@ core (Rails) plugins should live vs ChiliProject plugins (Engines) should be.

2011-10-14 09:27 pm - Eric Davis
I'd like to revisit this issue now for something else I'm working on (metrics on app and core plugins).

I propose we keep @vendor/plugins@ for Rails and core plugins and use @vendor/chiliproject_plugins@ for 3rd party plugins (engines). I just tested it 
with a few of my plugins and it looks like engines picks up the directory correctly.

Also thinking we could include this into 2.x since it's 100% backwards compatible.

(Changed the patch, was using RAILS_ENV instead of RAILS_ROOT or Rails.root)

2011-10-15 07:06 am - Holger Just
I noticed on our setup, that rake has some issues picking up tasks defined in plugins. This needs to be tested and fixed before a merge.

Also, just for the record, once we are on Rails3, plugins are going to be full Gems, installed by Bundler. What that means for Rake is still unclear to 
me...

2011-11-13 08:21 pm - Felix Schäfer
Holger Just wrote:
> that rake has some issues picking up tasks defined in plugins. This needs to be tested and fixed before a merge.

Any more info on this? Else I'd merge "Pull request 108":https://github.com/chiliproject/chiliproject/pull/108.

2011-12-09 09:44 pm - Eric Davis
- Target version set to 2.6.0

- Assignee changed from Holger Just to Eric Davis

- Status changed from Open to Closed

Merged into master. We'll need to start to encourage people to install plugins to @vendor/chiliproject_plugins@ now.
